<?php
// +---------------------------------------------------------------------------+
// | SocialShare_CM Plugin 1.2                                                 |
// +---------------------------------------------------------------------------+
// | codebase.php                                                              |
// |                                                                           |
// | This file provides the primary plugin code.                               |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009-2011 by the following authors:                         |
// |                                                                           |
// | Authors: Greg Gillis - greg DOT gillis AT sillig DOT com                  |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+


//We need these functions
	require_once('plugins/socialshare/templates/ss.template.class.php');


if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');


/**
 * Config file include - Edit config.php to select the popup type
 */
    require_once './plugins/socialshare/config.php';



//if the current page is displayimage.php then execute the function
if (defined('DISPLAYIMAGE_PHP')) {
	$thisplugin->add_filter('file_data','socialshare_file_data');	
}

// Add actions
$thisplugin->add_action('page_start','socialshare_page_start');

// Add an install action
$thisplugin->add_action('plugin_install','socialshare_install');

// Add an uninstall action
$thisplugin->add_action('plugin_uninstall','socialshare_uninstall');



function socialshare_list()
{
    global $_CONF, $_TABLES, $LANG21, $lang_plugin_socialshare, $_IMAGE_TYPE, $CONFIG;

    $retval = '';

    // writing the menu on top
    $menu_arr = array (
        array('url' => 'index.php?file=socialshare/index&action=config&socialshare=edit',
              'text' => $lang_plugin_socialshare['create_new']),
    );

    $retval .= socialshare_createMenu(
        $menu_arr,
        $lang_plugin_socialshare['menutext'],
		
//Add socialshare block image here
	$CONFIG['site_url'].'plugins/socialshare/images/admin/images/socialshare.png'
    );


$show_icons = admin_itemdisplay_socialshare(0,'admin_page');


$retval .= "<center>".$show_icons[1]."</center>"; 

    socialshare_reorder();

    // writing the list
    $header_arr = array(      # display 'text' and use table field 'field'
        array('text' => $lang_plugin_socialshare['edit'], 'field' => 'edit', 'sort' => false),
        array('text' => $lang_plugin_socialshare['order'], 'field' => 'shareorder', 'sort' => true),
        array('text' => $lang_plugin_socialshare['move'], 'field' => 'move', 'sort' => false),
        array('text' => $lang_plugin_socialshare['title'], 'field' => 'sharetitle', 'sort' => true),
        array('text' => $lang_plugin_socialshare['icon'], 'field' => 'shareimage', 'sort' => false),
        array('text' => $lang_plugin_socialshare['enabled'], 'field' => 'is_enabled', 'sort' => false)
    );

    $defsort_arr = array('field' => 'shareorder', 'direction' => 'asc');

    $text_arr = array(
        'has_extras' => true,
        'form_url'   =>  'index.php?file=socialshare/index&action=config'
    );

    $query_arr = array(
        'table' => 'socialshare',
        'sql' => "SELECT * FROM {$CONFIG['TABLE_PREFIX']}socialshare",
        'query_fields' => array('sharetitle', 'shareurl'),

    );

    $form_arr = array('bottom' => '<input type="hidden" name="shareenabler" value="1">');

    $retval .= socialshare_lister(
        'socialshare', 'socialshare_getListField', $header_arr, $text_arr,
        $query_arr, $defsort_arr, '', '', '', $form_arr
    );



    return $retval;
}


function socialshare_createMenu($menu_arr, $text, $icon = '')
{
    global $CONFIG;

    $admin_templates = new cmTemplate('plugins/socialshare/templates/lists');
    $admin_templates->set_file (
        array ('top_menu' => 'topmenu.thtml')
    );

    $menu_fields = '';
    $attr = array('class' => 'admin-menu-item');
    for ($i = 0; $i < count($menu_arr); $i++) {
        $menu_fields .= cm_createLink($menu_arr[$i]['text'], $menu_arr[$i]['url'], $attr);
        if ($i < (count($menu_arr) -1)) {
            $menu_fields .= ' | ';
        }
    }
    if (!empty ($icon)) {
        $attr = array('class' => 'admin-menu-icon');
        $icon = cm_createImage($icon, '', $attr);
        $admin_templates->set_var('icon', $icon);
    }
    $admin_templates->set_var('menu_fields', $menu_fields);
    $admin_templates->set_var('lang_instructions', $text);
    $admin_templates->set_var('site_url', $CONFIG['site_url']);
    $admin_templates->parse('top_menu', 'top_menu');
    $retval = $admin_templates->finish($admin_templates->get_var('top_menu'));

		
    return $retval;
	
	
}




function socialshare_page_start()
{
	global $CONFIG, $lang_plugin_socialshare;


//select the language file
	if (file_exists("plugins/socialshare/lang/{$CONFIG['lang']}.php")) {
		require_once "plugins/socialshare/lang/{$CONFIG['lang']}.php";
	} else {
		require_once "plugins/socialshare/lang/english.php";
	}
}



/**
*
*
*/
function socialshare_file_data($CURRENT_PIC_DATA)
{
    global $_CONF, $CONF_SOCIALSHARE, $lang_plugin_socialshare, $A, $CONFIG, $CPG_PHP_SELF;

    $retval = array();

    $sql = "SELECT * FROM {$CONFIG['TABLE_PREFIX']}socialshare WHERE is_enabled=1 ORDER BY shareorder asc;";

    $result = cpg_db_query($sql);
	

    $nrows = mysql_num_rows($result);

	if (is_image($CURRENT_PIC_DATA['filename'])){

		$html =& $CURRENT_PIC_DATA['html'];

//Show the share text above the icons on the photo pages
		$html = '<div class="Photo fn-container" id="PhotoContainer">' . $html . '</div>';
		$html .= '<link rel="stylesheet" href="'.$CONFIG['site_url'].'plugins/socialshare/socialshare.css" type="text/css" media="screen" charset="utf-8"/>';		
		$html .= '<div class="socialshare">';
		$html .= '<div class="socialshare_tagline"> '.$lang_plugin_socialshare['share'].'</div> <ul>';
	
	
	
	
//create the icons on the photo pages	
    for ($i = 0; $i < $nrows; $i++) {

        $B = mysql_fetch_array($result);

		if ($i == 1){
		$html .= '<li class="socialsharefirst">';
		}else{
		$html .= '<li>';
		}

    // Create our damned cage object
    $superCage = Inspekt::makeSuperCage();

//we need this
$_SERVER['HTTP_HOST'] = $superCage->server->getEscaped('HTTP_HOST');
$_SERVER['SCRIPT_NAME'] = $superCage->server->getEscaped('SCRIPT_NAME');

//this will link to the cm photo page instead of the photo url
//Replace <SHAREURL> with the photo page url
$B['shareurl'] = str_replace('<SHAREURL>', $_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'].'?pid='.$CURRENT_PIC_DATA['pid'], $B['shareurl']);

//this will create the url for the photo only. We need to add it so it picks up the querystring for the CM photo page.
//$B['shareurl'] = str_replace('<SHAREURL>', $CONFIG['site_url'].$CURRENT_PIC_DATA['url'], $B['shareurl']);

//GTG - check to see if the title below contains anything and if not try CURRENT_PIC_DATA['title']
//Replace <SHARETITLE> with the actual title
$B['shareurl'] = str_replace('<SHARETITLE>', $A['title'], $B['shareurl']);

//Replace <SHARETEXT> with the actual text
$B['shareurl'] = str_replace('<SHARETEXT>', (substr($A['6'], 0, 150)), $B['shareurl']);


        if ($B['shareorder'] ) {
		
        }

// if the config file is set to 0 then do the onclick popup method
	if ($CONF_SOCIALSHARE['popup'] == 0){

		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'" onclick="window.open(this.href, \'popupwindow\', \'width=750,height=436,scrollbars,resizable\'); return false;"><img src="'.$CONFIG['site_url'].'plugins/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="socialshare-hovers" /></a></li>';

// if the config file is set to 1 then do the _blank popup method		
	} elseif ($CONF_SOCIALSHARE['popup'] == 1){

		$html .= '<a rel="nofollow" target="_blank" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'"><img src="'.$CONFIG['site_url'].'plugins/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="socialshare-hovers" /></a></li>';

// if the config file is set to 2 then use the same browser instance		
	} elseif ($CONF_SOCIALSHARE['popup'] == 2){

		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'"><img src="'.$CONFIG['site_url'].'plugins/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="socialshare-hovers" /></a></li>';
		
	}


}

$html .= '</ul></div>';

}
	return $CURRENT_PIC_DATA;
	
}




/**
* Creates a list of data with a search, filter, clickable headers etc.
*/
function socialshare_lister($component, $fieldfunction, $header_arr, $text_arr,
            $query_arr, $defsort_arr, $filter = '', $extra = '',
            $options = '', $form_arr='')
{
    global $CONFIG, $_TABLES, $LANG_ACCESS, $LANG01, $_IMAGE_TYPE, $MESSAGE, $lang_plugin_socialshare;

    // set all variables to avoid warnings
    $retval = '';
    $filter_str = '';
    $order_sql = '';
    $limit = '';
    $prevorder = '';
    if (isset ($_GET['prevorder'])) { # what was the last sorting?
        $prevorder = cm_applyFilter ($_GET['prevorder']);
    }

    $query = '';
    if (isset ($_REQUEST['q'])) { // get query (text-search)
        $query = strip_tags(stripslashes($_REQUEST['q']));
    }

    $query_limit = '';
    if (isset($_REQUEST['query_limit'])) { // get query-limit (list-length)
        $query_limit = cm_applyFilter($_REQUEST['query_limit'], true);
        if ($query_limit == 0) {
            $query_limit = 50;
        }
    }

    // we assume that the current page is 1 to set it.
    $curpage = 1;
    $page = '';
    // get the current page from the interface. The variable is linked to the
    // component, i.e. the plugin/function calling this here to avoid overlap
    if (isset ($_REQUEST[$component . 'listpage'])) {
        $page = cm_applyFilter ($_REQUEST[$component . 'listpage'], true);
        $curpage = $page;
    }
    if ($curpage <= 0) {
        $curpage = 1; #current page has to be larger 0
    }

    $form_url = ''; # what is the form-url for the search button and list sorters?
    if (!empty ($text_arr['form_url'])) {
        $form_url = $text_arr['form_url'];
    }


    # get all template fields.
    $admin_templates = new cmTemplate('plugins/socialshare/templates/lists');
    $admin_templates->set_file (array (
        'search' => 'searchmenu.thtml',
        'list'   => 'list.thtml',
        'header' => 'header.thtml',
        'row'    => 'listitem.thtml',
        'field'  => 'field.thtml'
    ));
	


    # insert std. values into the template
//    $admin_templates->set_var( 'xhtml', XHTML );
    $admin_templates->set_var('site_url', $CONFIG['site_url']);
    $admin_templates->set_var('form_url', $form_url);
    $admin_templates->set_var('lang_edit', $lang_plugin_socialshare['edit']);
	
    if (isset($form_arr['top'])) {
        $admin_templates->set_var('formfields_top', $form_arr['top']);
//echo "form_arr['top'] = ".$form_arr['top'];		
    }
    if (isset($form_arr['bottom'])) {
        $admin_templates->set_var('formfields_bottom', $form_arr['bottom']);
    }

//////GTG - Delete from template - For use in a future version
        $admin_templates->set_var('show_deleteimage','display:none;');


//define the edit icon graphic and url
    $icons_type_arr = array('edit');
    $icon_arr = array();
    foreach ($icons_type_arr as $icon_type) {
        $icon_url = "plugins/socialshare/images/admin/images/$icon_type.png";
        $icon_arr[$icon_type] = cm_createImage($icon_url, $lang_plugin_socialshare[$icon_type]);
    }

	
    $has_extras = '';
    if (isset($text_arr['has_extras'])) { # does this one use extras? (search, google paging)
        $has_extras = $text_arr['has_extras'];
    }
    if ($has_extras) { // show search
        $admin_templates->set_var('lang_search', $lang_plugin_socialshare['search']);
        $admin_templates->set_var('lang_submit', $lang_plugin_socialshare['submit']);
        $admin_templates->set_var('lang_limit_results',
                                  $lang_plugin_socialshare['limit_results']);
        $admin_templates->set_var('last_query', htmlspecialchars($query));
        $admin_templates->set_var('filter', $filter);

    }
	

    $sql_query = addslashes($query); // replace quotes etc for security
    $sql = $query_arr['sql']; // get sql from array that builds data

    $order_var = ''; # number that is displayed in URL
    $order = '';     # field that is used in SQL
    $order_var_link = ''; # Variable for google paging.



    // is the order set in the link (when sorting the list)

    if ($_GET['order'] == '') {
        $order = $defsort_arr['field']; // no, get the default
    } else {
        $order_var = cm_applyFilter ($_GET['order'], true);
        $order_var_link = "&amp;order=$order_var"; # keep the variable for the google paging
        $order = $header_arr[$order_var]['field'];  # current order field name
    }
    $order_for_query = $order;

    $direction = '';
	
    if (!isset ($_GET['direction'])) { # get direction to sort after
        $direction = $defsort_arr['direction'];
    } else {
        $direction = cm_applyFilter ($_GET['direction']);
    }
    $direction = strtoupper ($direction);
    if ($order == $prevorder) { #reverse direction if prev. order was the same
        $direction = ($direction == 'DESC') ? 'ASC' : 'DESC';
    } else {
        $direction = ($direction == 'DESC') ? 'DESC' : 'ASC';
    }

    if ($direction == 'ASC') { # assign proper arrow img name dep. on sort order
        $arrow = 'bararrowdown';
    } else {
        $arrow = 'bararrowup';
    }
    # make actual order arrow image
    $img_arrow_url = "{$CONFIG['site_url']}plugins/socialshare/images/admin/images/$arrow.png";
    $img_arrow = '&nbsp;' . cm_createImage($img_arrow_url, $arrow);

    if (!empty ($order_for_query)) { # concat order string
        $order_sql = "ORDER BY $order_for_query $direction";
    }
    $th_subtags = ''; // other tags in the th, such as onclick and mouseover
    $header_text = ''; // title as displayed to the user
    // HEADER FIELDS array(text, field, sort, class)
    // this part defines the contents & format of the header fields

    for ($i=0; $i < count( $header_arr ); $i++) { #iterate through all headers
        $header_text = $header_arr[$i]['text'];
        $th_subtags = '';
        if ($header_arr[$i]['sort'] != false) { # is this sortable?
            if ($order==$header_arr[$i]['field']) { # is this currently sorted?
                $header_text .= $img_arrow;
            }
            # make the mouseover effect is sortable
            $th_subtags = " onmouseover=\"this.style.cursor='pointer';\"";
            $order_var = $i; # assign number to field so we know what to sort
            if (strpos ($form_url, '?') > 0) {
                $separator = '&amp;';
            } else {
                $separator = '?';
            }
            $th_subtags .= " onclick=\"window.location.href='$form_url$separator" // onclick action
                    ."order=$order_var&amp;prevorder=$order&amp;direction=$direction";
            if (!empty($page)) {
                $th_subtags .= '&amp;' . $component . 'listpage=' . $page;
            }
            if (!empty($query)) {
                $th_subtags .= '&amp;q=' . urlencode($query);
            }
            if (!empty($query_limit)) {
                $th_subtags .= '&amp;query_limit=' . $query_limit;
            }
            $th_subtags .= "';\"";
        }
        $admin_templates->set_var('class', "admin-list-headerfield");
        $admin_templates->set_var('header_text', $header_text);
        $admin_templates->set_var('th_subtags', $th_subtags);
        $admin_templates->parse('header_row', 'header', true);
        $admin_templates->clear_var('th_subtags'); // clear all for next header
        $admin_templates->clear_var('class');
        $admin_templates->clear_var('header_text');
    }

    if ($has_extras) {
	
        $limit = 50; # default query limit if not other chosen.
                     # maybe this could be a setting from the list?
        if (!empty($query_limit)) {
            $limit = $query_limit;
        }
        if ($query != '') { # set query into form after search
            $admin_templates->set_var ('query', urlencode($query) );
        } else {
            $admin_templates->set_var ('query', '');
        }
        $admin_templates->set_var ('query_limit', $query_limit);
        # choose proper dropdown field for query limit
        $admin_templates->set_var($limit . '_selected', 'selected="selected"');

        if (!empty($query_arr['default_filter'])){ # add default filter to sql
            $filter_str = " {$query_arr['default_filter']}";
        }
        if (!empty ($query)) { # add query fields with search term
            $filter_str .= " WHERE (";
            for ($f = 0; $f < count($query_arr['query_fields']); $f++) {
                $filter_str .= $query_arr['query_fields'][$f]
                            . " LIKE '%$sql_query%'";
                if ($f < (count($query_arr['query_fields']) - 1)) {
                    $filter_str .= " OR ";
                }
            }
            $filter_str .= ")";
        }
        $num_pages_sql = $sql . $filter_str;
        $num_pages_result = cpg_db_query($num_pages_sql);
        $num_rows = mysql_num_rows($num_pages_result);
        $num_pages = ceil ($num_rows / $limit);
        if ($num_pages < $curpage) { # make sure we dont go beyond possible results
               $curpage = 1;
        }
        $offset = (($curpage - 1) * $limit);
        $limit = "LIMIT $offset,$limit"; # get only current page data
        $admin_templates->set_var ('lang_records_found',
                                   $lang_plugin_socialshare['records_found']);

        $admin_templates->set_var ('records_found', $num_rows);
        $admin_templates->parse('search_menu', 'search', true);
    }

    # SQL
    $sql .= "$filter_str $order_sql $limit;";

    $result = cpg_db_query($sql);
    $nrows = mysql_num_rows($result);
    $r = 1; # r is the counter for the actual displayed rows for correct coloring
    for ($i = 0; $i < $nrows; $i++) { # now go through actual data
        $A = mysql_fetch_array($result);
        $this_row = false; # as long as no fields are returned, dont print row

        for ($j = 0; $j < count($header_arr); $j++) {
            $fieldname = $header_arr[$j]['field']; # get field name from headers
            $fieldvalue = '';
            if (!empty($A[$fieldname])) { # is there a field in data like that?

// show the icon if if it the shareimage field
			if ($fieldname == "shareimage"){
					$fieldvalue = '<img src="'.$CONFIG['site_url'].'plugins/socialshare/images/'.$A[$fieldname].'" alt="Edit">'; # yes, get its data
				}else{
					$fieldvalue = $A[$fieldname]; # yes, get its data
				}

            }
            if (!empty ($fieldfunction) && !empty ($extra)) {
                $fieldvalue = $fieldfunction ($fieldname, $fieldvalue, $A, $icon_arr, $extra);
            } else if (!empty ($fieldfunction)) { # do we have a fieldfunction?
                $fieldvalue = $fieldfunction ($fieldname, $fieldvalue, $A, $icon_arr);
            } else { # if not just take the value
                $fieldvalue = $fieldvalue;
            }
            if ($fieldvalue !== false) { # return was there, so write line
                $this_row = true;
            } else {
                $fieldvalue = ''; // dont give emtpy fields
            }
            if (!empty($header_arr[$j]['field_class'])) {
                $admin_templates->set_var('class', $header_arr[$j]['field_class']);
            } else {
                $admin_templates->set_var('class', "admin-list-field");
            }
			

            $admin_templates->set_var('itemtext', $fieldvalue); # write field
			
            $admin_templates->parse('item_field', 'field', true);
        }
        if ($this_row) { # there was data in at least one field, so print line
            $r++; # switch to next color
            $admin_templates->set_var('cssid', ($r%2)+1); # make alternating table color
            $admin_templates->parse('item_row', 'row', true); # process the complete row
        }
        $admin_templates->clear_var('item_field'); # clear field
    }

    if ($nrows==0) { # there is no data. return notification message.
        if (isset($text_arr['no_data'])) {
            $message = $text_arr['no_data']; # there is a user-message
        } else {
            $message = $lang_plugin_socialshare['no_results']; # take std.
        }
        $admin_templates->set_var('message', $message);
    }

    if ($has_extras) { # now make google-paging
        $hasargs = strstr( $form_url, '?' );
        if( $hasargs ) {
            $sep = '&amp;';
        } else {
            $sep = '?';
        }
        if (!empty($query)) { # port query to next page
            $base_url = $form_url . $sep . 'q=' . urlencode($query) . "&amp;query_limit=$query_limit$order_var_link&amp;direction=$direction";
        } else {
            $base_url = $form_url . $sep ."query_limit=$query_limit$order_var_link&amp;direction=$direction";
        }

        if ($num_pages > 1) { # print actual google-paging
            $admin_templates->set_var('google_paging',COM_printPageNavigation($base_url,$curpage,$num_pages, $component . 'listpage='));
        } else {
            $admin_templates->set_var('google_paging', '');
        }
    }

    $admin_templates->parse('output', 'list');

    // Do the actual output
    if (!empty($title)) {

    }
    $retval .= $admin_templates->finish($admin_templates->get_var('output'));
    if (!empty($title)) {

    }

    return $retval;
}



/**
 * used for the list of items in admin/plugins/socialshare/index.php
 *
 */
function socialshare_getListField($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $CONFIG, $LANG21, $_IMAGE_TYPE, $lang_plugin_socialshare;

    $retval = false;
	
	
if (GALLERY_ADMIN_MODE) {
$access = 3;

        switch($fieldname) {
            case 'edit':
                if ($access == 3) {
                    $retval = cm_createLink($icon_arr['edit'], "index.php?file=socialshare/index&action=config&socialshare=edit&amp;sid={$A['sid']}");
                }
                break;
            case 'title':
                $retval = stripslashes ($A['title']);
                if (empty ($retval)) {
                    $retval = '(' . $A['name'] . ')';
                }
                break;
            case 'shareorder':
                $retval .= $A['shareorder'];
                break;
            case 'is_enabled':
                if ($access == 3) {
                    if ($A['is_enabled'] == 1) {
                        $switch = ' checked="checked"';
                    } else {
                        $switch = '';
                    }
                    $retval = "<input type=\"checkbox\" name=\"enabledshare[{$A['sid']}]\" "
                        . "onclick=\"submit()\" value=\"\"$switch>";

                }
                break;
            case 'move':
                if ($access == 3) {
                        $sharecontrol_image = 'move-share.png';
                    $retval.="<img src=\"{$CONFIG['site_url']}plugins/socialshare/images/admin/images/$sharecontrol_image\" width=\"45\" height=\"20\" border=\"0\" usemap=\"#arrow{$A['sid']}\" alt=\"\">"
                            ."<map id=\"arrow{$A['sid']}\" name=\"arrow{$A['sid']}\">"
                            ."<area coords=\"0,0,12,20\"  title=\"{$lang_plugin_socialshare['moveleft']}\" href=\"index.php?file=socialshare/index&action=config&socialshare=move&amp;sid={$A['sid']}&amp;where=up&amp;alt=\"{$lang_plugin_socialshare['moveleft']}\">"
                            ."<area coords=\"30,0,43,20\" title=\"{$lang_plugin_socialshare['moveright']}\" href=\"index.php?file=socialshare/index&action=config&socialshare=move&amp;sid={$A['sid']}&amp;where=dn&amp; alt=\"{$lang_plugin_socialshare['moveright']}\">"
                            ."</map>";
                }
                break;
            default:
                $retval = $fieldvalue;
                break;
        }
    }

    return $retval;
}








// Install function
function socialshare_install() {

	global $CONFIG, $lang_plugin_as, $lang_plugin_as_config, $lang_plugin_asmgr, $thisplugin;

//We need some of the function in here	
		require 'include/sql_parse.php';	
	
//Create the table and insert the sample data
		$db_schema = $thisplugin->fullpath . '/schema.sql';
		$sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
		$sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);

		$sql_query = remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, ';');
		
		foreach($sql_query as $q) { 
			cpg_db_query($q);
		}
		return true;
}

//Uninstall the plugin
function socialshare_uninstall()
{
	global $CONFIG, $thisplugin;
	
		$f .= cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}socialshare");

	return true;
}

// Ask if admin wants to drop the table
function socialshare_cleanup($action) 
{
    global $lang_plugin_socialshare;
//    require ('plugins/active_search/include/init.inc.php');
    $superCage = Inspekt::makeSuperCage();
    $cleanup = $superCage->server->getEscaped('REQUEST_URI');

    if ($action===1) {
        echo <<< EOT
    <form action="{$cleanup}" method="post">
        <p>
            {$lang_plugin_socialshare['cleanup_question']}
        </p>
        <div style="margin:25;">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td><input type="radio" name="drop" value="1" /></td>
                <td>Yes</td>
            </tr>
            <tr>
                <td><input type="radio" name="drop" checked="checked" value="0" /></td>
                <td>No</td>
            </tr>
        </table>
        </div>
        <span>
           <input type="submit" name="submit" value="{$lang_plugin_socialshare['button_submit']}" /> &nbsp;&nbsp;&nbsp;
            <input type="button" name="cancel" onClick="window.location='pluginmgr.php';" value="{$lang_plugin_socialshare['button_cancel']}" />
        </span>
    </form>
EOT;
    }
}




/**
*
* Re-orders all entries in steps of 10
*
*/
function socialshare_reorder()
{
    global $_TABLES, $CONFIG;
    $sql = "SELECT * FROM {$CONFIG['TABLE_PREFIX']}socialshare ORDER BY shareorder asc;";
    $result = cpg_db_query($sql);
    $nrows = mysql_num_rows($result);

    $lastside = 0;
    $shareOrd = 10;
    $stepNumber = 10;

    for ($i = 0; $i < $nrows; $i++) {
        $A = mysql_fetch_array($result);

        if ($A['shareorder'] != $shareOrd) {  
            $q = "UPDATE " . $CONFIG['TABLE_PREFIX'] . "socialshare SET shareorder = '" .
                  $shareOrd . "' WHERE sid = '" . $A['sid'] ."'";
            cpg_db_query($q);
        }
        $shareOrd += $stepNumber;

    }
}



/**
* Enable and Disable an item
*/
function changeShareStatus($side, $sid_arr)
{
    global $_CONF, $_TABLES, $CONFIG;

    $side = cm_applyFilter($side, true);
    $sql = "UPDATE {$CONFIG['TABLE_PREFIX']}socialshare SET is_enabled = '0';";
    cpg_db_query($sql);

    if (isset($sid_arr)) {

        foreach ($sid_arr as $sid => $side) {
            $sid = cm_applyFilter($sid, true);
            // the enable those in the array
            $sql = "UPDATE {$CONFIG['TABLE_PREFIX']}socialshare SET is_enabled = '1' WHERE sid='$sid'";
            cpg_db_query($sql);
        }
    }
    return;
}



/**
* This function is only used for the admin page
*/

function admin_itemdisplay_socialshare($id, $type)
{
    global $_CONF, $lang_plugin_socialshare, $_TABLES, $A, $CONFIG;

    $retval = array();

    $sql = "SELECT * FROM {$CONFIG['TABLE_PREFIX']}socialshare WHERE is_enabled=1 ORDER BY shareorder asc;";
    $result = cpg_db_query($sql);
    $nrows = mysql_num_rows($result);

$html = '<link rel="stylesheet" href="'.$CONFIG['site_url'].'plugins/socialshare/socialshare.css" type="text/css" media="screen" charset="utf-8"/>';
$html .='<div class="socialshare"><div class="socialshare_tagline">'.$lang_plugin_socialshare['share'].'</div><ul>';

    for ($i = 0; $i < $nrows; $i++) {
        $B = mysql_fetch_array($result);

		if ($i == 1){
		$html .= '<li class="socialsharefirst">';
		}else{
		$html .= '<li>';
		}

	
if (!isset($A['sid']) && $type != "admin_page") {

   $story_id  = $template->get_var('story_id');
   $title     = $template->get_var('story_title');
   $introtext = $template->get_var('story_introtext');

} else {

   $story_id  = $A['sid'];
   $title     = $A['title'];
   $introtext = $A['introtext'];

}


$story_uri = cm_buildURL('#');

$B['shareurl'] = str_replace('<SHAREURL>', $story_uri, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETITLE>', $title, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETEXT>', (cm_truncate($introtext, 150, '...')), $B['shareurl']);


		

		


		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'" onclick="window.open(this.href, \'popupwindow\', \'width=750,height=436,scrollbars,resizable\'); return false;"><img src="plugins/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="socialshare-hovers" /></a></li>';


	}

		$html .= '</ul></div>';

	    $retval = array("SocialShare","{$html}");		
		
    return $retval;
}




/**
* Move selections UP, Down (left and right)
*
*/
function socialshare_move($sid, $where)
{
    global $CONFIG;

    $retval = '';

//Count the number of records with the selected sid (there should only be one)
    if (count(cpg_db_query("SELECT count(*) FROM {$CONFIG['TABLE_PREFIX']}socialshare WHERE sid={$sid}")) == 1) {	

//Which way did we move the selected record	
        switch ($where) {

            case ("up"): $q = "UPDATE {$CONFIG['TABLE_PREFIX']}socialshare SET shareorder = shareorder-11 WHERE sid = '" . $sid . "'";
                         cpg_db_query($q);
                         break;

            case ("dn"): $q = "UPDATE {$CONFIG['TABLE_PREFIX']}socialshare SET shareorder = shareorder+11 WHERE sid = '" . $sid . "'";
                         cpg_db_query($q);
                         break;
        }

    } else {

//GTG - Future - Add an entry to the error log here
    }

//Take us back to the config page and show us the order change	
    echo cm_refresh ('index.php?file=socialshare/index&action=config');	
    exit;
    return $retval;
}




//---------------------------------------------
/**
* Shows the socialshare item  editor
*
* This will show an edit form.  
*
*
*/
function socialshare_edit($sid = '')
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $LANG01, $LANG21, $LANG_ACCESS, $MESSAGE, $lang_plugin_socialshare, $CONFIG;

    $retval = '';
	

    // writing the menu on top
    $menu_arr = array (array('url' => '','text' => ''), );

    $retval .= socialshare_createMenu(
        $menu_arr,
        htmlspecialchars($lang_plugin_socialshare['edittext1']).$lang_plugin_socialshare['br'].$lang_plugin_socialshare['br'].htmlspecialchars($lang_plugin_socialshare['edittext2']),

//Add socialshare block image here
$CONFIG['site_url'].'plugins/socialshare/images/admin/images/socialshare.png'
    );	
	
	
	
	
	

// If we are editing an existing entry get the data from the database
    if (!empty($sid)) {
        $sql = "SELECT * FROM {$CONFIG['TABLE_PREFIX']}socialshare WHERE sid ='$sid'";

        $result = cpg_db_query($sql);
        $A = mysql_fetch_array($result);

    } else {
// If this is a new entry setup the default data	
        $A['sid'] = 0;
        $A['shareorder'] = 0;
        $A['shareurl'] = '';
        $A['sharetitle'] = '';
        $A['shareimage'] = '';		
        $A['is_enabled'] = 1;
		$A['owner_id'] = 2;
    }

	

	
	
// Set the template vars	
    $share_templates = new cmTemplate('plugins/socialshare/templates/');
    $share_templates->set_file('editor','shareeditor.thtml');



// Setup the delete button
	if (!empty($sid)) {
        $delbutton = '<input type="submit" value="' . $lang_plugin_socialshare['delete'] . '" name="mode"%s>';
	} else {
	$delbutton = '';
	}
        $jsconfirm = ' onclick="return confirm(\'' . $lang_plugin_socialshare['deleteok'] . '\');"';
        $share_templates->set_var ('delete_option', sprintf ($delbutton, $jsconfirm));


//ShareSID
    $share_templates->set_var('share_sid', $A['sid']);

//ShareOrder
    $share_templates->set_var('share_order', $A['shareorder']);
	
//Sharetitle
    $share_templates->set_var('lang_sharetitle', $lang_plugin_socialshare['title']);

//Save button text	
    $share_templates->set_var('lang_save', $lang_plugin_socialshare['save']);
	
//Cancel button text	
    $share_templates->set_var('lang_cancel', $lang_plugin_socialshare['cancel']);

//URL Description	
    $share_templates->set_var('lang_shareurl', $lang_plugin_socialshare['shareurl']);	
	
//image Description	
//    $share_templates->set_var('lang_shareimage', $lang_plugin_socialshare['shareimage']);		

//Share URL	
    $share_templates->set_var ('share_url',htmlspecialchars($A['shareurl']));

//Share Title	
    $share_templates->set_var ('share_title',htmlspecialchars (stripslashes ($A['sharetitle'])));	
	
//Share image	
//    $share_templates->set_var ('share_image',htmlspecialchars (stripslashes ($A['shareimage'])));
		
//Enabled Text
    $share_templates->set_var('lang_enabled', $lang_plugin_socialshare['enabled']);

//Show enabled checkbox	
    if ($A['is_enabled'] == 1) {
        $share_templates->set_var('is_enabled', 'checked="checked"');
    } else {
        $share_templates->set_var('is_enabled', '');
    }



//Grab all of the icon names to compare with and add a grey background if already used				
        $sqlC = "SELECT shareimage FROM {$CONFIG['TABLE_PREFIX']}socialshare";

        $resultC = cpg_db_query($sqlC);
		$nrowsC = mysql_num_rows($resultC);		


	

    for ($i = 0; $i < $nrowsC; $i++) {
        $C = mysql_fetch_array($resultC);


		}	


	
//show available icons with radio selector
    $share_templates->set_var('lang_icon', $lang_plugin_socialshare['shareicon']);
	if ($handle = opendir('plugins/socialshare/images')) {

	$icon_selection = '<table  border="0" align="right" cellpadding="1" cellspacing="1"> <tbody>';
	
	$count = 1;
    while (false !== ($file = readdir($handle))) {
	
        if ($file != "." && $file != ".." && $file != "Thumb.db") {

		if ($count == 1){
		$icon_selection .= '<tr>';
		}
		
	//remove the extension from the $file and add the trimmed string to filene (file no extension)
		$ext = strrchr($file, '.'); 
			if($ext !== false) 
			{ 
			$filene = substr($file, 0, -strlen($ext)); 
			} 

		
			
	
			
//if the filename matches what is in the database then make the background yellow to make it easier to find on screen			
			if ($A['shareimage'] == $file){			
				$icon_selection .= "<td style='width:150pt;border-top:solid windowtext 1.0pt;border-left:solid windowtext 1.0pt;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:yellow;text-align:right'><b>".$filene."&nbsp;</b><img src='plugins/socialshare/images/".$file."'><input type='radio' name='shareimage' value='".$file."' checked='true'/></td>";
			}else{
				$icon_selection .= "<td style='width:150pt;text-align:right'>".$filene."&nbsp;<img src='plugins/socialshare/images/".$file."'><input type='radio' name='shareimage' value='".$file."'/></td>";
			}


//show icons 4 rows across
		if ($count == 4){
		$icon_selection .= '</tr>';
		$count = 0;		
		}
		
		$count++;
		}


    
}	
//if we get the the end and it is not an even count of 4 then close the /tr	
		if ($count < 4){
		$icon_selection .= '</tr>';
		}

		$icon_selection .= 	'</tbody></table>';
	
    closedir($handle);
}	
    $share_templates->set_var('icon_selection', $icon_selection);	

	
//finishing up	
    $share_templates->parse('output', 'editor');
    $retval .= $share_templates->finish($share_templates->get_var('output'));

    return $retval;
}




/**
* Delete an item
*
*/
function socialshare_delete($sid)
{
    global $_CONF, $_TABLES, $_USER, $CONFIG;

cpg_db_query("DELETE FROM {$CONFIG['TABLE_PREFIX']}socialshare WHERE sid={$sid}");

return;	
}



/**
 * Create an HTML link
 *
 */
function cm_createLink($content, $url, $attr = array())
{
    $retval = '';

    $attr_str = 'href="' . $url . '"';
    foreach ($attr as $key => $value) {
        $attr_str .= " $key=\"$value\"";
    }
    $retval .= "<a $attr_str>$content</a>";

    return $retval;
}

/**
 * Create an HTML img
 *
 */
function cm_createImage($url, $alt = "", $attr = array())
{
    global $CONFIG;

    $retval = '';
    $attr_str = 'src="' . $url . '"';

    foreach ($attr as $key => $value) {
        $attr_str .= " $key=\"$value\"";
    }

    $retval = "<img $attr_str alt=\"$alt\" border=\"0\">";

    return $retval;
}



    /**
    * Builds crawler friendly URL if URL rewriting is enabled
    *
    */
    function cm_buildURL($url)
    {


        $pos = strpos($url,'?');
        $query_string = substr($url,$pos+1);
        $finalList = array();
        $paramList = explode('&',$query_string);
        for ($i = 1; $i <= count($paramList); $i++) {
            $keyValuePairs = explode('=',current($paramList));
            if (is_array($keyValuePairs)) {
                $argName = current($keyValuePairs);
                next($keyValuePairs);
                $finalList[$argName] = current($keyValuePairs);
            }
            next($paramList);
        }
        $newArgs = '/';
        for ($i = 1; $i <= count($finalList); $i++) {
            $newArgs .= current($finalList);
            if ($i <> count($finalList)) {
                $newArgs .= '/';
            }
            next($finalList);
        }
        return str_replace('?' . $query_string,$newArgs,$url);
    }    


/**
* Truncate a string
*
*/
function cm_truncate( $text, $maxlen, $filler = '', $endchars = 0 )
{
    $newlen = $maxlen - cm_MBYTE_strlen( $filler );
    $len = cm_MBYTE_strlen( $text );
    if( $len > $maxlen )
    {
        $text = cm_MBYTE_substr( $text, 0, $newlen - $endchars ) . $filler . cm_MBYTE_substr( $text, $len - $endchars, $endchars );
    }

    return $text;
}


function cm_MBYTE_strlen($str)
{
    static $mb_enabled;
	
    if (!isset($mb_enabled)) {
        $mb_enabled = cm_MBYTE_checkEnabled();
    }
    if ($mb_enabled) {
        $result = mb_strlen($str);
    } else {
        $result = strlen($str);
    }

    return $result;
}

function cm_MBYTE_substr($str, $start, $length = NULL)
{
    static $mb_enabled;

    if (!isset($mb_enabled)) {
        $mb_enabled = cm_MBYTE_checkEnabled();
    }
    if ($mb_enabled) {
        if( $length === NULL )
        {
            $result = mb_substr($str, $start);
        } else {
            $result = mb_substr($str, $start, $length);
        }
    } else {
        if( $length === NULL )
        {
            $result = substr($str, $start);
        } else {
            $result = substr($str, $start, $length);
        }
    }

    return $result;
}


function cm_MBYTE_checkEnabled($test = '', $enabled = true)
{
    global $LANG_CHARSET;

    static $mb_enabled;

    if (!isset($mb_enabled)) {
        $mb_enabled = false;
        if (strcasecmp($LANG_CHARSET, 'utf-8') == 0) {			
            if (empty($test)) {
                // Normal situation in live environment
                if (function_exists('mb_eregi_replace')) {
                    $mb_enabled = mb_internal_encoding('UTF-8');
                }
            } elseif ($test == 'test') {
                // Just for tests, true if we want function to exist
                if ($enabled) {
                    $mb_enabled = mb_internal_encoding('UTF-8');
                }
            } elseif ($test == 'test-reset') {
                // Just for tests, allow resetting $mb_enabled
                if (isset($mb_enabled)) {
                    unset($mb_enabled);
                }
            }
        }
    }

    return $mb_enabled;
}	



/**
* Filter parameters passed per GET (URL) or POST.
*
*/
function cm_applyFilter( $parameter, $isnumeric = false )
{
    $p = stripslashes($parameter);

    return cm_applyBasicFilter($p, $isnumeric);
}

/**
* Filter parameters
*
*/
function cm_applyBasicFilter( $parameter, $isnumeric = false )
{
    $log_manipulation = false; // set to true to log when the filter applied

    $p = strip_tags( $parameter );
    $p = cm_killJS( $p ); // doesn't help a lot right now, but still ...

    if( $isnumeric )
    {
        // Note: PHP's is_numeric() accepts values like 4e4 as numeric
        if( !is_numeric( $p ) || ( preg_match( '/^-?\d+$/', $p ) == 0 ))
        {
            $p = 0;
        }
    }
    else
    {
        $p = preg_replace( '/\/\*.*/', '', $p );
        $pa = explode( "'", $p );
        $pa = explode( '"', $pa[0] );
        $pa = explode( '`', $pa[0] );
        $pa = explode( ';', $pa[0] );
        $pa = explode( ',', $pa[0] );
        $pa = explode( '\\', $pa[0] );
        $p = $pa[0];
    }

    if( $log_manipulation )
    {
        if( strcmp( $p, $parameter ) != 0 )
        {
//            COM_errorLog( "Filter applied: >> $parameter << filtered to $p [IP {$_SERVER['REMOTE_ADDR']}]", 1);
        }
    }

    return $p;
}

/**
*  Takes some amount of text and replaces all javascript events on*= with in
*
*/

function cm_killJS( $Message )
{
    return( preg_replace( '/(\s)+[oO][nN](\w*) ?=/', '\1in\2=', $Message ));
}


    /**
    * Returns the contents of one cell from a MySQL result set
    *
    */
    function cmdbResult($recordset,$row,$field=0)
    {
        if ($this->isVerbose()) {
            $this->_errorlog("\n*** Inside database->dbResult ***");
            if (empty($recordset)) {
                $this->_errorlog("\n*** Passed recordset isn't valid ***");
            } else {
                $this->_errorlog("\n*** Everything looks good ***");
            }
            $this->_errorlog("\n*** Leaving database->dbResult ***");
        }
        return @mysql_result($recordset,$row,$field);
    }	
	
/**
* Redirects user to a given URL
*
*/
function cm_refresh($url)
{
    return "<html><head><meta http-equiv=\"refresh\" content=\"0; URL=$url\"></head></html>\n";
}


/**
* Saves a Share item
*
*/
function socialshare_save ($sid, $shareorder, $shareurl, $sharetitle, $shareimage, $is_enabled)
{
    global $CONFIG, $_TABLES, $lang_plugin_socialshare, $LANG21, $MESSAGE, $LANG_SOCIALSHARE_0;

    $retval = '';
	
    $sharetitle = addslashes (stripslashes (strip_tags ($sharetitle)));

    if (empty($sharetitle)) {

				
				$retval .= $lang_plugin_socialshare['empty_title'];
				$retval .= socialshare_edit($sid);								
        return $retval;
    }


	if (!empty($sharetitle) && !empty($shareurl) && !empty($shareimage) ) {	
        if ($is_enabled == 'on') {
            $is_enabled = 1;
        } else {
            $is_enabled = 0;
        }

// If this is an existing record then save the updated values otherwise insert a new record
        if ($sid > 0) {
		
cpg_db_query("REPLACE INTO {$CONFIG['TABLE_PREFIX']}socialshare (sid,shareorder, shareurl, sharetitle, shareimage, is_enabled) VALUES ('{$sid}','{$shareorder}','{$shareurl}', '{$sharetitle}','{$shareimage}','{$is_enabled}')");

        } else {
//If this is a new record then save it here		
            $sql = "INSERT INTO {$CONFIG['TABLE_PREFIX']}socialshare "
             .'(shareorder,shareurl,sharetitle,shareimage,is_enabled) '
             ."VALUES ('$shareorder','$shareurl','$sharetitle','$shareimage',$is_enabled)";
				cpg_db_query($sql);
				$sid = mysql_insert_id();
        }


//Show the message that the record has been saved
		echo $lang_plugin_socialshare['record_saved'];
		
//Take us back to the config page and show us the order change	
    return cm_refresh ('index.php?file=socialshare/index&action=config');	
		
    } else {

//Show the message that this is something missing	
            $retval .= $lang_plugin_socialshare['err_missing_fields'];		

//reload the edit page
$retval .= socialshare_edit($sid);				

    }

    return $retval;
}


?>