<?php
// +---------------------------------------------------------------------------+
// | SocialShare Plugin 1.2                                                    |
// +---------------------------------------------------------------------------+
// | configuration.php                                                           |
// |                                                                           |
// | This file provides helper functions for the automatic plugin install.     |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009-2011 by the following authors:                         |
// |                                                                           |
// | Authors: Greg Gillis - greg DOT gillis AT sillig DOT com                  |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

//We need these functions
require_once('include/init.inc.php');

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}

//We need these to sort the admin headers
	if($superCage->get->keyExists('prevorder')){
$_GET['prevorder'] = $superCage->get->getAlpha ('prevorder');	
$_GET['direction'] = $superCage->get->getAlpha ('direction');	
$_GET['order'] = $superCage->get->getDigits ('order');	
	}

//We need this for the search to work properly
	if($superCage->post->keyExists('q')){
$_REQUEST['q'] = $superCage->post->getAlpha('q');	
}



if (!GALLERY_ADMIN_MODE) {
  cpg_die($lang_common['error'], $lang_errors['access_denied'], __FILE__, __LINE__);
}

///////////////////////////////////////////////////////////////////////
/////////////////   HANDLE OF INCOMING ACTIONS  (if any)  /////////////
///////////////////////////////////////////////////////////////////////



//if a checkbox was clicked then call changeShareStatus()
	if($superCage->post->keyExists('shareenabler')){
		$enabledshare = array();

			if($superCage->post->keyExists('enabledshare')){
				$enabledshare = $superCage->post->getAlpha('enabledshare');
			}
		
		changeShareStatus($superCage->post->getAlpha('shareenabler'), $enabledshare);
	
	}	


	//get the action from the querystring. The only action should be config
	if($superCage->post->keyExists('action')){
		$action = $superCage->post->getAlpha('action');
	} else {
		$action = $superCage->get->getAlpha('action');
	}

switch ($action) {


  case 'config':
	if ($superCage->post->keyExists('socialshare_display')) {

	  if ($superCage->post->getInt('socialshare_display') == 1) {
        $value = 1;
      } elseif ($superCage->post->getInt('socialshare_display') == 0) {
          $value = 0;
      } else {
        $value = 2;
      }
      if ($value != $CONFIG['plugin_socialshare_display']) {
        $f= cpg_db_query("UPDATE {$CONFIG['TABLE_PREFIX']}socialshare SET value = '{$value}' WHERE name = 'plugin_socialshare_display'");
        if (version_compare(COPPERMINE_VERSION, '1.5.1') == -1) {
            $header_location = (@preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE'))) ? 'Refresh: 0; URL=' : 'Location: ';
            $redirect = "index.php?file=socialshare/index&action=config";
            header($header_location . $redirect);
            pageheader('Information', "<meta http-equiv=\"refresh\" content=\"0;url=$redirect\" />");
            msg_box('Information', 'Settings changed for SocialShare Plugin', 'continue', $redirect);
            pagefooter();
            ob_end_flush();
            exit;
        } else {
            cpgRedirectPage('index.php?file=socialshare/index&action=config', $lang_common['information'], 'Settings changed for Socialshare Plugin', 1);
        }
      }
    } else {
      $message_id = '';
    }
	
    pageheader('Configuration of plugin &quot;SocialShare&quot;');



//Call the edit function when the edit icon is clicked
	if ($superCage->get->getAlpha('socialshare')=='edit') {
		//Grab the sid from the querystring
		$sid = $superCage->get->getDigits('sid');
			//call the edit function
			echo socialshare_edit($sid);	
          break;
	}


	
	

//Call the delete function when selected
	if ($superCage->post->getAlpha('mode')=='Delete') {
		//Grab the sid from the querystring
		$sid = $superCage->post->getDigits('sid');
		
			//call the delete function
			echo socialshare_delete($sid);	
			
			//after the delete is complete call the list function to show the results
			echo socialshare_list();	
			
		  break;
	}

	
	

//Call the save function when selected
	if ($superCage->post->getAlpha('mode')=='Save') {
		//Grab the sid from the querystring
		$sid = $superCage->post->getDigits('sid');

	
		$shareorder = $superCage->post->getDigits('shareorder');
		$shareurl = htmlspecialchars_decode($superCage->post->getEscaped('shareurl'));
		$sharetitle = $superCage->post->getAlpha('sharetitle');
		$shareimage = $superCage->post->getEscaped('shareimage');
	if ($superCage->post->keyExists('is_enabled')) {		
		$is_enabled = $superCage->post->getAlpha('is_enabled');
	} else {
	$is_enabled = '0';
	}

			//call the save function
			echo socialshare_save($sid, $shareorder, $shareurl, $sharetitle, $shareimage, $is_enabled);	
			
			//after the save is complete call the list function to show the results
	
			
		  break;
	}	

	

	//Call the Move function when selected
	if ($superCage->get->getAlpha('socialshare')=='move') {
		//Grab the sid and where from the querystring	
		$sid = $superCage->get->getRaw('sid');
		$where = $superCage->get->getRaw('where');

			//call the move function
			echo socialshare_move($sid, $where);
			
			//after the move is complete call the list function to show the results
			echo socialshare_list();	
			
          break;	
	}	
	
	
	
	
			//Call the admin list
			echo socialshare_list();	
			
          break;
		  
		  

		  
  //The default action if there is an error
  default:
          cpg_die (ERROR, 'Plugin &quot;SocialShare&quot;: Unknown action value', __FILE__, __LINE__);
         break;		  
}


//Finish up
pagefooter();
ob_end_flush();
?>